package progressiveClientServer.receiveProxy;

import java.io.IOException;
import java.net.InetSocketAddress;

import progressiveClientServer.receiveProxy.handlers.DoubleValueHandler;
import progressiveClientServer.receiveProxy.handlers.NegateValueHandler;
import progressiveClientServer.receiveProxy.handlers.DefaultHandler;
import progressiveClientServer.receiveProxy.common.Constants;

import com.sun.net.httpserver.HttpServer;

public class ServerCommunicator {
	private static final int MAX_WAITING_CONNECTIONS = 10;
	
	private HttpServer server;
	
	private ServerCommunicator() {}

	private void run() {

		try {
			server = HttpServer.create(
				new InetSocketAddress(Constants.SERVER_PORT_NUMBER),
				MAX_WAITING_CONNECTIONS);
		} 
		catch (IOException e) {
			System.out.println("Could not create HTTP server: " + e.getMessage());
			e.printStackTrace();
			return;
		}

		server.setExecutor(null); // use the default executor
		
		server.createContext(Constants.DOUBLE_VALUE_DESIGNATOR, 
				             new DoubleValueHandler());
		server.createContext(Constants.NEGATE_VALUE_DESIGNATOR,
				             new NegateValueHandler());
		server.createContext(Constants.DEFAULT_DESIGNATOR,
				             new DefaultHandler());

		server.start();
	}
	
	public static void main(String[] args) {
		new ServerCommunicator().run();
	}

}
