package progressiveClientServer.sendingObjects;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import progressiveClientServer.gettingBackObject.Person;

import com.google.gson.Gson;
import com.google.gson.JsonIOException;
import com.google.gson.JsonSyntaxException;

public class ClientCommunicator {
//Singleton
	public static ClientCommunicator SINGLETON = new ClientCommunicator();

	//Static variables
	private static Gson gson = new Gson();
	
//Attributes
	
//Constructors
	public ClientCommunicator() {}
		
//Commands
	public Object send() {
		HttpURLConnection connection = 
			openConnection(COMMAND_HANDLER_DESIGNATOR, HTTP_POST, "123abc", true);
		Person person = new Person("Steve Stevenon", 23);
		sendToServerCommunicator(connection, person);
		getResult(connection, null);

		return null;
	}
	
	public static void main(String[] args) {
		ClientCommunicator.SINGLETON.send();
	}
		

//Auxiliary Constants, Attributes, and Methods
	private static final String SERVER_HOST = "localhost";
	private static final String URL_PREFIX = "http://" + SERVER_HOST + ":" + ServerCommunicator.getServerPortNumber();
	private static final String HTTP_POST = "POST";
	private static final String COMMAND_HANDLER_DESIGNATOR = "/";
	
	private HttpURLConnection openConnection(String contextIdentifier,
											 String requestMethod,
											 String authorizationCode,
            								 boolean sendingSomthingToServer)
	{
		HttpURLConnection result = null;
		try {
			URL url = new URL(URL_PREFIX + contextIdentifier);
			result = (HttpURLConnection)url.openConnection();
			result.setRequestMethod(requestMethod);
			result.setDoOutput(sendingSomthingToServer);
			result.setRequestProperty(AUTHORIZATION_KEY, authorizationCode);
			result.connect();
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return result;
	}
	
	private void sendToServerCommunicator(HttpURLConnection connection,
            							  Object objectToSend)
	{
		PrintWriter printWriter = null;
		try {
			printWriter = new PrintWriter(connection.getOutputStream());
			//Encoding in JSON
			gson.toJson(objectToSend, printWriter);
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if(printWriter != null) {
				printWriter.close();
			}
		}
	}
	
	private Object getResult(HttpURLConnection connection, Class<?> klass) {
		Object result = null;
		try {
			if (connection.getResponseCode() == HttpURLConnection.HTTP_OK) {
				//0 means the body response length == 0; it was empty
				if(connection.getContentLength() == 0) {
					System.out.println("Response body was empty");
				} else if(connection.getContentLength() == -1) {
					System.out.println("ERROR: The response body should have been empty");
				}
			} else {
				throw new Exception(String.format("http code %d",	connection.getResponseCode()));
			}
		} catch (JsonSyntaxException | JsonIOException | IOException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return result;
	}
	
	public static final String AUTHORIZATION_KEY = "authorization";
}
